Index: /branches/2013/dev_r3853_CNRS9_ConfSetting/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zsms.F90
===================================================================
--- /branches/2013/dev_r3853_CNRS9_ConfSetting/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zsms.F90	(revision 3874)
+++ /branches/2013/dev_r3853_CNRS9_ConfSetting/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zsms.F90	(revision 3875)
@@ -166,9 +166,15 @@
       NAMELIST/nampisdmp/ ln_pisdmp, nn_pisdmp, ln_pisclo
       NAMELIST/nampismass/ ln_check_mass
-      !!----------------------------------------------------------------------
-
-
-      REWIND( numnatp )
-      READ  ( numnatp, nampisbio )
+      INTEGER :: ios                 ! Local integer output status for namelist read
+      !!----------------------------------------------------------------------
+
+      REWIND( numnatp_ref )              ! Namelist nampisbio in reference namelist : Pisces variables
+      READ  ( numnatp_ref, nampisbio, IOSTAT = ios, ERR = 901)
+901   IF( ios /= 0 ) CALL ctl_nam ( ios , 'nampisbio in reference namelist', lwp )
+
+      REWIND( numnatp_cfg )              ! Namelist nampisbio in configuration namelist : Pisces variables
+      READ  ( numnatp_cfg, nampisbio, IOSTAT = ios, ERR = 902 )
+902   IF( ios /= 0 ) CALL ctl_nam ( ios , 'nampisbio in configuration namelist', lwp )
+      WRITE ( numonp, nampisbio )
 
       IF(lwp) THEN                         ! control print
@@ -193,6 +199,12 @@
       xkr_mass_max = 1.
 
-      REWIND( numnatp )                     ! read natkriest
-      READ  ( numnatp, nampiskrp )
+      REWIND( numnatp_ref )              ! Namelist nampiskrp in reference namelist : Pisces Kriest
+      READ  ( numnatp_ref, nampiskrp, IOSTAT = ios, ERR = 903)
+903   IF( ios /= 0 ) CALL ctl_nam ( ios , 'nampiskrp in reference namelist', lwp )
+
+      REWIND( numnatp_cfg )              ! Namelist nampiskrp in configuration namelist : Pisces Kriest
+      READ  ( numnatp_cfg, nampiskrp, IOSTAT = ios, ERR = 904 )
+904   IF( ios /= 0 ) CALL ctl_nam ( ios , 'nampiskrp in configuration namelist', lwp )
+      WRITE ( numonp, nampiskrp )
 
       IF(lwp) THEN
@@ -217,6 +229,12 @@
       ln_pisclo = .false.
 
-      REWIND( numnatp )
-      READ  ( numnatp, nampisdmp )
+      REWIND( numnatp_ref )              ! Namelist nampisdmp in reference namelist : Pisces damping
+      READ  ( numnatp_ref, nampisdmp, IOSTAT = ios, ERR = 905)
+905   IF( ios /= 0 ) CALL ctl_nam ( ios , 'nampisdmp in reference namelist', lwp )
+
+      REWIND( numnatp_cfg )              ! Namelist nampisdmp in configuration namelist : Pisces damping
+      READ  ( numnatp_cfg, nampisdmp, IOSTAT = ios, ERR = 906 )
+906   IF( ios /= 0 ) CALL ctl_nam ( ios , 'nampisdmp in configuration namelist', lwp )
+      WRITE ( numonp, nampisdmp )
 
       IF(lwp) THEN                         ! control print
@@ -230,6 +248,13 @@
 
       ln_check_mass = .false.
-      REWIND( numnatp )       
-      READ  ( numnatp, nampismass )
+      REWIND( numnatp_ref )              ! Namelist nampismass in reference namelist : Pisces mass conservation check
+      READ  ( numnatp_ref, nampismass, IOSTAT = ios, ERR = 907)
+907   IF( ios /= 0 ) CALL ctl_nam ( ios , 'nampismass in reference namelist', lwp )
+
+      REWIND( numnatp_cfg )              ! Namelist nampismass in configuration namelist : Pisces mass conservation check 
+      READ  ( numnatp_cfg, nampismass, IOSTAT = ios, ERR = 908 )
+908   IF( ios /= 0 ) CALL ctl_nam ( ios , 'nampismass in configuration namelist', lwp )
+      WRITE ( numonp, nampismass )
+
       IF(lwp) THEN                         ! control print
          WRITE(numout,*) ' '
Index: /branches/2013/dev_r3853_CNRS9_ConfSetting/NEMOGCM/NEMO/TOP_SRC/PISCES/sms_pisces.F90
===================================================================
--- /branches/2013/dev_r3853_CNRS9_ConfSetting/NEMOGCM/NEMO/TOP_SRC/PISCES/sms_pisces.F90	(revision 3874)
+++ /branches/2013/dev_r3853_CNRS9_ConfSetting/NEMOGCM/NEMO/TOP_SRC/PISCES/sms_pisces.F90	(revision 3875)
@@ -17,5 +17,7 @@
    PUBLIC
 
-   INTEGER ::   numnatp
+   INTEGER ::   numnatp_ref = -1           !! Logical units for namelist pisces
+   INTEGER ::   numnatp_cfg = -1           !! Logical units for namelist pisces
+   INTEGER ::   numonp      = -1           !! Logical unit for namelist pisces output
 
    !!*  Biological fluxes for light : variables shared by pisces & lobster
Index: /branches/2013/dev_r3853_CNRS9_ConfSetting/NEMOGCM/NEMO/TOP_SRC/PISCES/trcnam_pisces.F90
===================================================================
--- /branches/2013/dev_r3853_CNRS9_ConfSetting/NEMOGCM/NEMO/TOP_SRC/PISCES/trcnam_pisces.F90	(revision 3874)
+++ /branches/2013/dev_r3853_CNRS9_ConfSetting/NEMOGCM/NEMO/TOP_SRC/PISCES/trcnam_pisces.F90	(revision 3875)
@@ -49,4 +49,5 @@
       !!
       INTEGER :: jl, jn
+      INTEGER :: ios                 ! Local integer output status for namelist read
       TYPE(DIAG), DIMENSION(jp_pisces_2d)  :: pisdia2d
       TYPE(DIAG), DIMENSION(jp_pisces_3d)  :: pisdia3d
@@ -69,6 +70,7 @@
 #endif
       IF(lwp) WRITE(numout,*) ' ~~~~~~~~~~~~~~'
-      CALL ctl_opn( numnatp, TRIM( clname ), 'OLD', 'FORMATTED', 'SEQUENTIAL', -1, numout, .FALSE. )
-
+      CALL ctl_opn( numnatp_ref, TRIM( clname )//'_ref', 'OLD'    , 'FORMATTED', 'SEQUENTIAL', -1, numout, .FALSE. )
+      CALL ctl_opn( numnatp_cfg, TRIM( clname )//'_cfg', 'OLD'    , 'FORMATTED', 'SEQUENTIAL', -1, numout, .FALSE. )
+      CALL ctl_opn( numonp     , 'output.namelist.pis' , 'REPLACE', 'FORMATTED', 'SEQUENTIAL', -1, numout, .FALSE. )
       !
       IF( .NOT.lk_iomput .AND. ln_diatrc ) THEN
@@ -88,6 +90,12 @@
          END DO
 
-         REWIND( numnatp )               ! 
-         READ  ( numnatp, nampisdia )
+         REWIND( numnatp_ref )              ! Namelist nampisdia in reference namelist : Pisces diagnostics
+         READ  ( numnatp_ref, nampisdia, IOSTAT = ios, ERR = 901)
+901      IF( ios /= 0 ) CALL ctl_nam ( ios , 'nampisdia in reference namelist', lwp )
+
+         REWIND( numnatp_cfg )              ! Namelist nampisdia in configuration namelist : Pisces diagnostics
+         READ  ( numnatp_cfg, nampisdia, IOSTAT = ios, ERR = 902 )
+902      IF( ios /= 0 ) CALL ctl_nam ( ios , 'nampisdia in configuration namelist', lwp )
+         WRITE ( numonp, nampisdia )
 
          DO jl = 1, jp_pisces_2d
@@ -140,6 +148,12 @@
          END DO
 
-         REWIND( numnatp )
-         READ  ( numnatp, nampisdbi )
+         REWIND( numnatp_ref )              ! Namelist nampisdbi in reference namelist : Pisces add. diagnostics
+         READ  ( numnatp_ref, nampisdbi, IOSTAT = ios, ERR = 903)
+903      IF( ios /= 0 ) CALL ctl_nam ( ios , 'nampisdbi in reference namelist', lwp )
+
+         REWIND( numnatp_cfg )              ! Namelist nampisdbi in configuration namelist : Pisces add. diagnostics
+         READ  ( numnatp_cfg, nampisdbi, IOSTAT = ios, ERR = 904 )
+904      IF( ios /= 0 ) CALL ctl_nam ( ios , 'nampisdbi in configuration namelist', lwp )
+         WRITE ( numonp, nampisdbi )
 
          DO jl = 1, jp_pisces_trd
Index: /branches/2013/dev_r3853_CNRS9_ConfSetting/NEMOGCM/NEMO/TOP_SRC/TRP/trcnam_trp.F90
===================================================================
--- /branches/2013/dev_r3853_CNRS9_ConfSetting/NEMOGCM/NEMO/TOP_SRC/TRP/trcnam_trp.F90	(revision 3874)
+++ /branches/2013/dev_r3853_CNRS9_ConfSetting/NEMOGCM/NEMO/TOP_SRC/TRP/trcnam_trp.F90	(revision 3875)
@@ -15,4 +15,5 @@
    USE trc                 ! ocean passive tracers variables
    USE in_out_manager      ! ocean dynamics and active tracers variables
+   USE lib_mpp           ! distributed memory computing library
 
    IMPLICIT NONE
@@ -73,4 +74,5 @@
       !! ** Purpose :   Read Namelist for tracer transport option
       !!----------------------------------------------------------------------
+      INTEGER ::  ios                 ! Local integer output status for namelist read
       NAMELIST/namtrc_adv/ ln_trcadv_cen2 , ln_trcadv_tvd   ,    &
          &                 ln_trcadv_muscl, ln_trcadv_muscl2,    &
@@ -92,6 +94,12 @@
       IF(lwp) WRITE(numout,*) ' ~~~~~~~~~~~'
 
-      REWIND ( numnat )               ! Read Namelist namtrc_adv : tracer advection scheme
-      READ   ( numnat, namtrc_adv )
+      REWIND( numnat_ref )              ! Namelist namtrc_adv in reference namelist : Tracer advection scheme
+      READ  ( numnat_ref, namtrc_adv, IOSTAT = ios, ERR = 901)
+901   IF( ios /= 0 ) CALL ctl_nam ( ios , 'namtrc_adv in reference namelist', lwp )
+
+      REWIND( numnat_cfg )              ! Namelist namtrc_adv in configuration namelist : Tracer advection scheme
+      READ  ( numnat_cfg, namtrc_adv, IOSTAT = ios, ERR = 902 )
+902   IF( ios /= 0 ) CALL ctl_nam ( ios , 'namtrc_adv in configuration namelist', lwp )
+      WRITE ( numont, namtrc_adv )
 
       IF(lwp) THEN                    ! Namelist print
@@ -108,6 +116,12 @@
       ENDIF
       !
-      REWIND( numnat )                ! Namelist namtrc_ldf
-      READ  ( numnat, namtrc_ldf )
+      REWIND( numnat_ref )              ! Namelist namtrc_ldf in reference namelist : Tracer lateral diffusive operator
+      READ  ( numnat_ref, namtrc_ldf, IOSTAT = ios, ERR = 903)
+903   IF( ios /= 0 ) CALL ctl_nam ( ios , 'namtrc_ldf in reference namelist', lwp )
+
+      REWIND( numnat_cfg )              ! Namelist namtrc_ldf in configuration namelist : Tracer lateral diffusive operator
+      READ  ( numnat_cfg, namtrc_ldf, IOSTAT = ios, ERR = 904 )
+904   IF( ios /= 0 ) CALL ctl_nam ( ios , 'namtrc_ldf in configuration namelist', lwp )
+      WRITE ( numont, namtrc_ldf )
 
       IF(lwp) THEN                    ! Namelist print
@@ -127,6 +141,12 @@
 
       !                                ! Vertical mixing
-      REWIND( numnat )                 !   ! Read namtopzdf namelist
-      READ  ( numnat, namtrc_zdf )
+      REWIND( numnat_ref )              ! Namelist namtrc_zdf in reference namelist : Tracer vertical mixing
+      READ  ( numnat_ref, namtrc_zdf, IOSTAT = ios, ERR = 905)
+905   IF( ios /= 0 ) CALL ctl_nam ( ios , 'namtrc_zdf in reference namelist', lwp )
+
+      REWIND( numnat_cfg )              ! Namelist namtrc_zdf in configuration namelist : Tracer vertical mixing
+      READ  ( numnat_cfg, namtrc_zdf, IOSTAT = ios, ERR = 906 )
+906   IF( ios /= 0 ) CALL ctl_nam ( ios , 'namtrc_zdf in configuration namelist', lwp )
+      WRITE ( numont, namtrc_zdf )
 
       IF(lwp) THEN                     !   ! Control print
@@ -138,6 +158,12 @@
 
       !
-      REWIND( numnat )                 !   Read Namelist namtoprad
-      READ  ( numnat, namtrc_rad )
+      REWIND( numnat_ref )              ! Namelist namtrc_rad in reference namelist : Tracer negative concentrations
+      READ  ( numnat_ref, namtrc_rad, IOSTAT = ios, ERR = 907)
+907   IF( ios /= 0 ) CALL ctl_nam ( ios , 'namtrc_rad in reference namelist', lwp )
+
+      REWIND( numnat_cfg )              ! Namelist namtrc_rad in configuration namelist : Tracer negative concentrations
+      READ  ( numnat_cfg, namtrc_rad, IOSTAT = ios, ERR = 908 )
+908   IF( ios /= 0 ) CALL ctl_nam ( ios , 'namtrc_rad in configuration namelist', lwp )
+      WRITE ( numont, namtrc_rad )
 
       IF(lwp) THEN                     !   ! Control print
@@ -149,6 +175,13 @@
 
 # if defined key_trcdmp
-      REWIND ( numnat )                  ! Read Namelist namtra_dmp : temperature and salinity damping term
-      READ   ( numnat, namtrc_dmp )
+      REWIND( numnat_ref )              ! Namelist namtrc_dmp in reference namelist : Passive tracers newtonian damping
+      READ  ( numnat_ref, namtrc_dmp, IOSTAT = ios, ERR = 909)
+909   IF( ios /= 0 ) CALL ctl_nam ( ios , 'namtrc_dmp in reference namelist', lwp )
+
+      REWIND( numnat_cfg )              ! Namelist namtrc_dmp in configuration namelist : Passive tracers newtonian damping
+      READ  ( numnat_cfg, namtrc_dmp, IOSTAT = ios, ERR = 910)
+910   IF( ios /= 0 ) CALL ctl_nam ( ios , 'namtrc_dmp in configuration namelist', lwp )
+      WRITE ( numont, namtrc_dmp )
+
       IF( lzoom )   nn_zdmp_trc = 0           ! restoring to climatology at closed north or south boundaries
 
Index: /branches/2013/dev_r3853_CNRS9_ConfSetting/NEMOGCM/NEMO/TOP_SRC/trc.F90
===================================================================
--- /branches/2013/dev_r3853_CNRS9_ConfSetting/NEMOGCM/NEMO/TOP_SRC/trc.F90	(revision 3874)
+++ /branches/2013/dev_r3853_CNRS9_ConfSetting/NEMOGCM/NEMO/TOP_SRC/trc.F90	(revision 3875)
@@ -21,6 +21,8 @@
 
    !! parameters for the control of passive tracers
-   !! --------------------------------------------------
-   INTEGER, PUBLIC                                                 ::   numnat        !: logicla unit for the passive tracer NAMELIST
+   !! ---------------------------------------------   
+   INTEGER, PUBLIC                                                 ::   numnat_ref = -1   !: logical unit for the reference passive tracer namelist_top_ref
+   INTEGER, PUBLIC                                                 ::   numnat_cfg = -1   !: logical unit for the reference passive tracer namelist_top_cfg
+   INTEGER, PUBLIC                                                 ::   numont     = -1   !: logical unit for the reference passive tracer namelist output output.namelist.top
    INTEGER, PUBLIC                                                 ::   numstr        !: logical unit for tracer statistics
    INTEGER, PUBLIC                                                 ::   numrtr        !: logical unit for trc restart (read )
Index: /branches/2013/dev_r3853_CNRS9_ConfSetting/NEMOGCM/NEMO/TOP_SRC/trcdta.F90
===================================================================
--- /branches/2013/dev_r3853_CNRS9_ConfSetting/NEMOGCM/NEMO/TOP_SRC/trcdta.F90	(revision 3874)
+++ /branches/2013/dev_r3853_CNRS9_ConfSetting/NEMOGCM/NEMO/TOP_SRC/trcdta.F90	(revision 3875)
@@ -53,6 +53,7 @@
       !!----------------------------------------------------------------------
       !
-      INTEGER            :: jl, jn                   ! dummy loop indicies
+      INTEGER            :: jl, jn                           ! dummy loop indicies
       INTEGER            :: ierr0, ierr1, ierr2, ierr3       ! temporary integers
+      INTEGER            :: ios                              ! Local integer output status for namelist read
       CHARACTER(len=100) :: clndta, clntrc
       REAL(wp)           :: zfact
@@ -103,6 +104,12 @@
       END DO
       !
-      REWIND( numnat )               ! read nattrc
-      READ  ( numnat, namtrc_dta )
+      REWIND( numnat_ref )              ! Namelist namtrc_dta in reference namelist : Passive tracer input data
+      READ  ( numnat_ref, namtrc_dta, IOSTAT = ios, ERR = 901)
+901   IF( ios /= 0 ) CALL ctl_nam ( ios , 'namtrc_dta in reference namelist', lwp )
+
+      REWIND( numnat_cfg )              ! Namelist namtrc_dta in configuration namelist : Passive tracer input data
+      READ  ( numnat_cfg, namtrc_dta, IOSTAT = ios, ERR = 902 )
+902   IF( ios /= 0 ) CALL ctl_nam ( ios , 'namtrc_dta in configuration namelist', lwp )
+      WRITE ( numont, namtrc_dta )
 
       IF( lwp ) THEN
Index: /branches/2013/dev_r3853_CNRS9_ConfSetting/NEMOGCM/NEMO/TOP_SRC/trcnam.F90
===================================================================
--- /branches/2013/dev_r3853_CNRS9_ConfSetting/NEMOGCM/NEMO/TOP_SRC/trcnam.F90	(revision 3874)
+++ /branches/2013/dev_r3853_CNRS9_ConfSetting/NEMOGCM/NEMO/TOP_SRC/trcnam.F90	(revision 3875)
@@ -55,4 +55,5 @@
       !!---------------------------------------------------------------------
       INTEGER ::  jn, ierr
+      INTEGER ::  ios                 ! Local integer output status for namelist read
       ! Definition of a tracer as a structure
       TYPE(PTRACER), DIMENSION(jptra) :: sn_tracer  ! type of tracer for saving if not key_iomput
@@ -73,5 +74,7 @@
       IF(lwp) WRITE(numout,*) '~~~~~~~'
 
-      CALL ctl_opn( numnat, 'namelist_top', 'OLD', 'FORMATTED', 'SEQUENTIAL', 1, numout, .FALSE. )
+      CALL ctl_opn( numnat_ref, 'namelist_top_ref'   , 'OLD'    , 'FORMATTED', 'SEQUENTIAL', 1, numout, .FALSE. )
+      CALL ctl_opn( numnat_cfg, 'namelist_top_cfg'   , 'OLD'    , 'FORMATTED', 'SEQUENTIAL', 1, numout, .FALSE. )
+      CALL ctl_opn( numont    , 'output.namelist.top', 'REPLACE', 'FORMATTED', 'SEQUENTIAL',-1, numout, .FALSE. )
 
       ! Namelist nattrc (files)
@@ -95,7 +98,12 @@
       ln_trcdmp = .FALSE.
 
-
-      REWIND( numnat )               ! read nattrc
-      READ  ( numnat, namtrc )
+      REWIND( numnat_ref )              ! Namelist namtrc in reference namelist : Passive tracer variables
+      READ  ( numnat_ref, namtrc, IOSTAT = ios, ERR = 901)
+901   IF( ios /= 0 ) CALL ctl_nam ( ios , 'namtrc in reference namelist', lwp )
+
+      REWIND( numnat_cfg )              ! Namelist namtrc in configuration namelist : Passive tracer variables
+      READ  ( numnat_cfg, namtrc, IOSTAT = ios, ERR = 902 )
+902   IF( ios /= 0 ) CALL ctl_nam ( ios , 'namtrc in configuration namelist', lwp )
+      WRITE ( numont, namtrc )
 
       DO jn = 1, jptra
@@ -142,6 +150,12 @@
       nn_writebio = 10
 
-      REWIND( numnat )               !  namelist namtoptrd : passive tracer trends diagnostic
-      READ  ( numnat, namtrc_dia )
+      REWIND( numnat_ref )              ! Namelist namtrc_dia in reference namelist : Passive tracer diagnostics
+      READ  ( numnat_ref, namtrc_dia, IOSTAT = ios, ERR = 903)
+903   IF( ios /= 0 ) CALL ctl_nam ( ios , 'namtrc_dia in reference namelist', lwp )
+
+      REWIND( numnat_cfg )              ! Namelist namtrc_dia in configuration namelist : Passive tracer diagnostics
+      READ  ( numnat_cfg, namtrc_dia, IOSTAT = ios, ERR = 904 )
+904   IF( ios /= 0 ) CALL ctl_nam ( ios , 'namtrc_dia in configuration namelist', lwp )
+      WRITE ( numont, namtrc_dia )
 
       IF(lwp) THEN
@@ -221,6 +235,12 @@
          ln_trdtrc(:) = .FALSE.
 
-         REWIND( numnat )               !  namelist namtoptrd : passive tracer trends diagnostic
-         READ  ( numnat, namtrc_trd )
+         REWIND( numnat_ref )              ! Namelist namtrc_trd in reference namelist : Passive tracer trends
+         READ  ( numnat_ref, namtrc_trd, IOSTAT = ios, ERR = 905)
+905      IF( ios /= 0 ) CALL ctl_nam ( ios , 'namtrc_trd in reference namelist', lwp )
+
+         REWIND( numnat_cfg )              ! Namelist namtrc_trd in configuration namelist : Passive tracer trends
+         READ  ( numnat_cfg, namtrc_trd, IOSTAT = ios, ERR = 906 )
+906      IF( ios /= 0 ) CALL ctl_nam ( ios , 'namtrc_trd in configuration namelist', lwp )
+         WRITE ( numont, namtrc_trd )
 
          IF(lwp) THEN
